Package org.eclipse.cdt.core.browser

## Class IndexTypeInfo

- java.lang.Object
- - org.eclipse.cdt.core.browser.IndexTypeInfo

All Implemented Interfaces:
  `IFunctionInfo`, `ITypeInfo`

    public class IndexTypeInfo
    extends Object
    implements ITypeInfo, IFunctionInfo

Restriction:
  This interface is not intended to be extended by clients.
Restriction:
  This class is not intended to be instantiated by clients.

### Field Summary

### Fields inherited from interface org.eclipse.cdt.core.browser.ITypeInfo

`KNOWN_TYPES`

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
`void` `addDerivedReference​(ITypeReference location)` Deprecated.
`void` `addReference​(ITypeReference location)` Deprecated.
`boolean` `canSubstituteFor​(ITypeInfo info)` Deprecated.
`static IndexTypeInfo` `create​(IndexTypeInfo rhs, ITypeReference ref)`
`static IndexTypeInfo` `create​(IIndex index, IIndexBinding binding)` Creates a type info suitable for the binding.
`static IndexTypeInfo` `create​(IIndex index, IIndexMacro macro)` Creates a type info object suitable for a macro.
`boolean` `encloses​(ITypeInfo info)` Deprecated.
`boolean` `equals​(Object obj)` Type info objects are equal if they compute the same references.
`boolean` `exists()` Deprecated.
`int` `getCElementType()` Returns the CElement type.
`ITypeReference[]` `getDerivedReferences()` Deprecated.
`ITypeInfo[]` `getEnclosedTypes()` Deprecated.
`ITypeInfo[]` `getEnclosedTypes​(int[] kinds)` Deprecated.
`ITypeInfo` `getEnclosingNamespace​(boolean includeGlobalNamespace)` Deprecated.
`ICProject` `getEnclosingProject()` Returns the enclosing project.
`ITypeInfo` `getEnclosingType()` Deprecated.
`ITypeInfo` `getEnclosingType​(int[] kinds)` Deprecated.
`String` `getName()` Returns the type name.
`String[]` `getParameters()`
`IQualifiedTypeName` `getQualifiedTypeName()` Returns the qualified type name.
`ITypeReference[]` `getReferences()` Returns the originating locations where this type was declared.
`ITypeReference` `getResolvedReference()` Returns the real location where type was declared.
`String` `getReturnType()`
`ITypeInfo` `getRootNamespace​(boolean includeGlobalNamespace)` Deprecated.
`ITypeInfo[]` `getSubTypes()` Deprecated.
`ASTAccessVisibility` `getSuperTypeAccess​(ITypeInfo subType)` Deprecated.
`ITypeInfo[]` `getSuperTypes()` Deprecated.
`boolean` `hasEnclosedTypes()` Deprecated.
`int` `hashCode()`
`boolean` `hasSubTypes()` Deprecated.
`boolean` `hasSuperTypes()` Deprecated.
`boolean` `isClass()` Deprecated.
`boolean` `isEnclosed​(ITypeInfo info)` Deprecated.
`boolean` `isEnclosed​(ITypeSearchScope scope)` Deprecated.
`boolean` `isEnclosedType()` Deprecated.
`boolean` `isEnclosingType()` Deprecated.
`boolean` `isFileLocal()`
`boolean` `isReferenced​(ITypeSearchScope scope)` Deprecated.
`boolean` `isUndefinedType()` Deprecated.
`void` `setCElementType​(int type)` Deprecated.

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

### Method Detail

#### create

    public static IndexTypeInfo create​(IIndex index,
                                       IIndexBinding binding)

Creates a type info suitable for the binding.

Parameters:
  `index` - a non-null index in which to locate references
  `binding` -
Since:
  4.0.1

#### create

    public static IndexTypeInfo create​(IIndex index,
                                       IIndexMacro macro)

Creates a type info object suitable for a macro.

Parameters:
  `index` - a non-null index in which to locate references
  `macro` - a macro to create a type info for
Since:
  4.0.1

#### create

    public static IndexTypeInfo create​(IndexTypeInfo rhs,
                                       ITypeReference ref)

Since:
  5.1

#### getCElementType

    public int getCElementType()

Description copied from interface: `ITypeInfo`
Returns the CElement type.

Specified by:
  `getCElementType` in interface `ITypeInfo`
Returns:
  ICElement.C_NAMESPACE, C_CLASS, C_STRUCT, C_UNION, C_ENUMERATION, or C_TYPEDEF, or zero if unknown type.

#### getEnclosingProject

    public ICProject getEnclosingProject()

Description copied from interface: `ITypeInfo`
Returns the enclosing project.

Specified by:
  `getEnclosingProject` in interface `ITypeInfo`

#### getName

    public String getName()

Description copied from interface: `ITypeInfo`
Returns the type name.

Specified by:
  `getName` in interface `ITypeInfo`

#### getQualifiedTypeName

    public IQualifiedTypeName getQualifiedTypeName()

Description copied from interface: `ITypeInfo`
Returns the qualified type name.

Specified by:
  `getQualifiedTypeName` in interface `ITypeInfo`

#### getParameters

    public String[] getParameters()

Specified by:
  `getParameters` in interface `IFunctionInfo`
Returns:
  the function parameter types

#### getReturnType

    public String getReturnType()

Specified by:
  `getReturnType` in interface `IFunctionInfo`
Returns:
  the function return type

#### hashCode

    public int hashCode()

Overrides:
  `hashCode` in class `Object`

#### equals

    public boolean equals​(Object obj)

Type info objects are equal if they compute the same references.

Overrides:
  `equals` in class `Object`

#### isFileLocal

    public boolean isFileLocal()

Since:
  5.1

#### getResolvedReference

    public ITypeReference getResolvedReference()

Description copied from interface: `ITypeInfo`
Returns the real location where type was declared.

Specified by:
  `getResolvedReference` in interface `ITypeInfo`
Returns:
  the parsed source reference (with offset and length), or `null` if not found.

#### getReferences

    public ITypeReference[] getReferences()

Description copied from interface: `ITypeInfo`
Returns the originating locations where this type was declared.

Specified by:
  `getReferences` in interface `ITypeInfo`
Returns:
  all known source references, or an empty array if none found.

#### addDerivedReference

    @Deprecated
    public void addDerivedReference​(ITypeReference location)

Deprecated.

Specified by:
  `addDerivedReference` in interface `ITypeInfo`
Restriction:
  This method is not intended to be referenced by clients.

#### addReference

    @Deprecated
    public void addReference​(ITypeReference location)

Deprecated.

Specified by:
  `addReference` in interface `ITypeInfo`
Restriction:
  This method is not intended to be referenced by clients.

#### canSubstituteFor

    @Deprecated
    public boolean canSubstituteFor​(ITypeInfo info)

Deprecated.

Specified by:
  `canSubstituteFor` in interface `ITypeInfo`
Restriction:
  This method is not intended to be referenced by clients.

#### encloses

    @Deprecated
    public boolean encloses​(ITypeInfo info)

Deprecated.

Specified by:
  `encloses` in interface `ITypeInfo`
Restriction:
  This method is not intended to be referenced by clients.

#### exists

    @Deprecated
    public boolean exists()

Deprecated.

Specified by:
  `exists` in interface `ITypeInfo`
Restriction:
  This method is not intended to be referenced by clients.

#### getDerivedReferences

    @Deprecated
    public ITypeReference[] getDerivedReferences()

Deprecated.

Specified by:
  `getDerivedReferences` in interface `ITypeInfo`
Restriction:
  This method is not intended to be referenced by clients.

#### getEnclosedTypes

    @Deprecated
    public ITypeInfo[] getEnclosedTypes()

Deprecated.

Specified by:
  `getEnclosedTypes` in interface `ITypeInfo`
Restriction:
  This method is not intended to be referenced by clients.

#### getEnclosedTypes

    @Deprecated
    public ITypeInfo[] getEnclosedTypes​(int[] kinds)

Deprecated.

Specified by:
  `getEnclosedTypes` in interface `ITypeInfo`
Restriction:
  This method is not intended to be referenced by clients.

#### getEnclosingNamespace

    @Deprecated
    public ITypeInfo getEnclosingNamespace​(boolean includeGlobalNamespace)

Deprecated.

Specified by:
  `getEnclosingNamespace` in interface `ITypeInfo`
Restriction:
  This method is not intended to be referenced by clients.

#### getEnclosingType

    @Deprecated
    public ITypeInfo getEnclosingType()

Deprecated.

Specified by:
  `getEnclosingType` in interface `ITypeInfo`
Restriction:
  This method is not intended to be referenced by clients.

#### getEnclosingType

    @Deprecated
    public ITypeInfo getEnclosingType​(int[] kinds)

Deprecated.

Specified by:
  `getEnclosingType` in interface `ITypeInfo`
Restriction:
  This method is not intended to be referenced by clients.

#### getRootNamespace

    @Deprecated
    public ITypeInfo getRootNamespace​(boolean includeGlobalNamespace)

Deprecated.

Specified by:
  `getRootNamespace` in interface `ITypeInfo`
Restriction:
  This method is not intended to be referenced by clients.

#### getSubTypes

    @Deprecated
    public ITypeInfo[] getSubTypes()

Deprecated.

Specified by:
  `getSubTypes` in interface `ITypeInfo`
Restriction:
  This method is not intended to be referenced by clients.

#### getSuperTypeAccess

    @Deprecated
    public ASTAccessVisibility getSuperTypeAccess​(ITypeInfo subType)

Deprecated.

Specified by:
  `getSuperTypeAccess` in interface `ITypeInfo`
Restriction:
  This method is not intended to be referenced by clients.

#### getSuperTypes

    @Deprecated
    public ITypeInfo[] getSuperTypes()

Deprecated.

Specified by:
  `getSuperTypes` in interface `ITypeInfo`
Restriction:
  This method is not intended to be referenced by clients.

#### hasEnclosedTypes

    @Deprecated
    public boolean hasEnclosedTypes()

Deprecated.

Specified by:
  `hasEnclosedTypes` in interface `ITypeInfo`
Restriction:
  This method is not intended to be referenced by clients.

#### hasSubTypes

    @Deprecated
    public boolean hasSubTypes()

Deprecated.

Specified by:
  `hasSubTypes` in interface `ITypeInfo`
Restriction:
  This method is not intended to be referenced by clients.

#### hasSuperTypes

    @Deprecated
    public boolean hasSuperTypes()

Deprecated.

Specified by:
  `hasSuperTypes` in interface `ITypeInfo`
Restriction:
  This method is not intended to be referenced by clients.

#### isClass

    @Deprecated
    public boolean isClass()

Deprecated.

Specified by:
  `isClass` in interface `ITypeInfo`
Restriction:
  This method is not intended to be referenced by clients.

#### isEnclosed

    @Deprecated
    public boolean isEnclosed​(ITypeInfo info)

Deprecated.

Specified by:
  `isEnclosed` in interface `ITypeInfo`
Restriction:
  This method is not intended to be referenced by clients.

#### isEnclosed

    @Deprecated
    public boolean isEnclosed​(ITypeSearchScope scope)

Deprecated.

Specified by:
  `isEnclosed` in interface `ITypeInfo`
Restriction:
  This method is not intended to be referenced by clients.

#### isEnclosedType

    @Deprecated
    public boolean isEnclosedType()

Deprecated.

Specified by:
  `isEnclosedType` in interface `ITypeInfo`
Restriction:
  This method is not intended to be referenced by clients.

#### isEnclosingType

    @Deprecated
    public boolean isEnclosingType()

Deprecated.

Specified by:
  `isEnclosingType` in interface `ITypeInfo`
Restriction:
  This method is not intended to be referenced by clients.

#### isReferenced

    @Deprecated
    public boolean isReferenced​(ITypeSearchScope scope)

Deprecated.

Specified by:
  `isReferenced` in interface `ITypeInfo`
Restriction:
  This method is not intended to be referenced by clients.

#### isUndefinedType

    @Deprecated
    public boolean isUndefinedType()

Deprecated.

Specified by:
  `isUndefinedType` in interface `ITypeInfo`
Restriction:
  This method is not intended to be referenced by clients.

#### setCElementType

    @Deprecated
    public void setCElementType​(int type)

Deprecated.

Specified by:
  `setCElementType` in interface `ITypeInfo`
Restriction:
  This method is not intended to be referenced by clients.